//
//	conservedHHFor2.c
//
//	Programming:	Koich Hagiwara
//

#include "myHeader.h"
extern	pSummerizedSNPdata sumSNP;
extern	long	totalAnnotationDataCount;
extern	long	*chrPosition;
extern	double	threshold;
extern	char	**stFile[];
extern	long	*nEffectiveSNP[ 2 ];
extern	double	totalGenetDistance, totalGenetDistanceWOX;
extern	int		lastChromosome;
extern	FILE	**tempFile;
extern	long	largeGap;

// Obtain RCHHs.
// The patients' number starts from 0.
void	conservedHaplotypeFor2( int pt1, int pt2, int tgPool, int isRepresentative, int chrNo ) {
	long	i, j, start, end;
	int		flag;
	double	genet, typeAFP, regFP;
	double	m;
	
	if( chrPosition[ chrNo + 1 ] - chrPosition[ chrNo ] == 0 ) {
		return;
	}

	for( i = chrPosition[ chrNo ];i < chrPosition[ chrNo + 1 ]; ++ i ){
		sumSNP[ i ].start = 0;
		sumSNP[ i ].end = 0;
	}

	genet = 0.0; regFP = 0;
	for ( start = chrPosition[ chrNo ], j = chrPosition[ chrNo ] + 1; j < chrPosition[ chrNo + 1 ]; ++j ) {		//	j moves within a chromosome
		if ( ( isHetero( j, pt1, pt2 ) != 1 ) && ( j != chrPosition[ chrNo + 1 ] - 1 ) ) {		//	If SNP is not heterozygous and not at the end of the chromosome...
		//	For excluding centromere....   You can undef LARGEGAP and only sumSNP[].genetMap is used as a criteria for defining a region.
			if ( sumSNP[ j + 1 ].position - sumSNP[ j ].position < largeGap ) {
				continue;
			}																
		}
		end = j;																					//	If heterozygous, set up a temporary end boundary.
		if ( sumSNP[ end ].genetMap - sumSNP[ start ].genetMap >= threshold ) {
			sumSNP[ start ].start = 1; sumSNP[ end ].end = 1;											//	if the region is sufficiently large, define an RCHH.
			if ( start != chrPosition[ chrNo ] ) {
				if ( sumSNP[ start ].position - sumSNP[ start - 1 ].position < largeGap ) {
					regFP += 0.5;
				}
			}
			if ( end != chrPosition[ chrNo + 1 ] - 1 ) {
				if ( sumSNP[ end + 1 ].position - sumSNP[ end ].position < largeGap ) {
					regFP += 0.5;
				}
			}
			genet += sumSNP[ end ].genetMap - sumSNP[ start ].genetMap;									//	calculate the distance
		}
		if ( j != chrPosition[ chrNo + 1 ] - 1 ) {
			if ( sumSNP[ j + 1 ].position - sumSNP[ j ].position >= largeGap ) {
				start = end + 1;
			}
			else {
				start = end;
			}
		}
	}
	
	if ( pt1 < pt2 ) {
		if ( isRepresentative == 0 ) {
			fprintf ( tempFile[ chrNo ], "(%d,%d)\t", pt1 + 1, pt2 + 1 );											// Internally patients number start from 0.  For output, it starts from 1.
		} else {
			fprintf ( tempFile[ chrNo ], "(%d,representative)\t", pt1 + 1 );											// Internally patients number start from 0.  For output, it starts from 1.
		}
		typeAFP = falsePositive( threshold, nEffectiveSNP[ tgPool ][ pt1 * ( lastChromosome - EXCLUDE_X ) + chrNo ], nEffectiveSNP[ tgPool ][ pt2 * ( lastChromosome - EXCLUDE_X ) + chrNo ], &m, chrNo );
		if ( isRepresentative == 0 ) {
			fprintf ( tempFile[ chrNo ], "%9.2f\t%s\t%s\t%11.2f\t%9.4f\t%14ld\t%14ld\t", threshold, fileNameBody( stFile[ tgPool ][ pt1 ] ), fileNameBody( stFile[ tgPool ][ pt2 ] ), genet, genet / ( sumSNP[ chrPosition[ chrNo + 1 ] - 1 ].genetMap - sumSNP[ chrPosition[ chrNo ] ].genetMap ), nEffectiveSNP[ tgPool ][ pt1 * ( lastChromosome - EXCLUDE_X ) + chrNo ], nEffectiveSNP[ tgPool ][ pt2 * ( lastChromosome - EXCLUDE_X ) + chrNo ] );
		} else {
			fprintf ( tempFile[ chrNo ], "%9.2f\t%s\trepresentative\t%11.2f\t%9.4f\t%14ld\t%14ld\t", threshold, fileNameBody( stFile[ tgPool ][ pt1 ] ), genet, genet / ( sumSNP[ chrPosition[ chrNo + 1 ] - 1 ].genetMap - sumSNP[ chrPosition[ chrNo ] ].genetMap ), nEffectiveSNP[ tgPool ][ pt1 * ( lastChromosome - EXCLUDE_X ) + chrNo ], nEffectiveSNP[ tgPool ][ pt2 * ( lastChromosome - EXCLUDE_X ) + chrNo ] );
		}
		fprintf ( tempFile[ chrNo ], "%13.4f\t%13.4f\n", typeAFP, regFP * m / totalGenetDistanceWOX );
	}
	
	//determine the overlapped region
	flag = 0;
	for ( j = chrPosition[ chrNo ]; j < chrPosition[ chrNo + 1 ]; ++j ) {									//	j moves within a chromosome
		if ( sumSNP[ j ].start == 1 ) {
			flag = 1; 
			if ( isRepresentative == 0 ) {
				( sumSNP[ j ].foldOverlap[ pt1 ] )++;
				( sumSNP[ j ].foldOverlap[ pt2 ] )++;
			} else {
				( sumSNP[ j ].foldOverlap[ pt2 ] )++;
			}
		}
		else if ( sumSNP[ j ].end == 1 ) {
			//	To avoid duplicate counting.
			if ( sumSNP[ j ].start != 1 ) {
				if ( isRepresentative == 0 ) {
					( sumSNP[ j ].foldOverlap[ pt1 ] )++;
					( sumSNP[ j ].foldOverlap[ pt2 ] )++;
				} else {
					( sumSNP[ j ].foldOverlap[ pt2 ] )++;
				}
			}
			flag = 0; 
		} else {
			if ( isRepresentative == 0 ) {
				sumSNP[ j ].foldOverlap[ pt1 ] += flag;
				sumSNP[ j ].foldOverlap[ pt2 ] += flag;
			} else {
				sumSNP[ j ].foldOverlap[ pt2 ] += flag;
			}
		}
	}
	return;
}

// 1 if HH is hetero, 0 if others.
int		isHetero ( long i, int pt1, int pt2 ) {
	if( ( sumSNP[ i ].expandedGType[ pt1 ] == 1 && sumSNP[ i ].expandedGType[ pt2 ] == 2 ) || ( sumSNP[ i ].expandedGType[ pt1 ] == 2 && sumSNP[ i ].expandedGType[ pt2 ] == 1 ) )
		return (1);
	else 
		return (0);
}


