//
//	customCombinationHH.c
//
//	Programming:	Koich Hagiwara
//

#include "myHeader.h"

extern	pSummerizedSNPdata sumSNP;
extern	int	noTgPool[ 2 ];
extern	long	totalAnnotationDataCount;
extern	struct	incReg	includeRegion[]; 
extern	long	noRegions;
extern	char	*outputFilePath;
extern	char	*targetSt[ 2 ];
extern	unsigned int	maxOverlap;
extern	unsigned int	*maxOverlapChr;
extern	int		lastChromosome;
extern	FILE	**tempFile;
extern	long	*chrPosition;
extern	char	stringTgPool[ 2 ][ 12 ];
extern	char	foldOverlapFileFlagPSHeader;
extern	char	*foldOverlapFileFlagTXT;
extern	int		enum_patients;

//********************


int	customCombinationHH ( ) {
	
	int		flag = 0;
	long	i, j;
	int		len, temp, noNumerics;
	unsigned int	noSelectedPt;
	// An array of flags that indicate patients who are to analyze.
	char	tempStr1[ BUFFERSIZE ], tempStr2[ BUFFERSIZE ];
	FILE	*inf;
	FILE	*outf;
	char	outfilename[ BUFFERSIZE ], infilename[ BUFFERSIZE ];
	char	stringBuffer1[ STRINGBUFFERSIZE ];
	int	chrNo;
	
	for( i = 0; i < noTgPool[ 0 ]; ++ i ) { targetSt[ enum_patients ][ i ] = 0; }
	fprintf( stderr, "\nInput the numbers for the subjects among whom you wish to obtain the RCHHs (just hit return to exit) ");
	fgets( tempStr2, 255, stdin );
	if ( ( tempStr2[ 0 ] == 10 ) || ( tempStr2[ 0 ] == 13 ) ) {
//		fprintf( stderr, "\nExiting program\n" );
		return( 0 );
	}
	len = strlen ( tempStr2 );
	for ( i = 0, noNumerics = 0; i < len; ++ i) {
		//	If non-numeric character is found, replace with null.
		if ( ( tempStr2[ i ] < '0' ) || ( tempStr2[ i ] > '9' ) ) {
			tempStr2[ i ] = 0;
			continue;
		}
		else {
			++noNumerics;
		}
	}	
	//	At this point, the string is broken into numeric fragmens.
	if ( noNumerics == 0 ) {
		fprintf( stderr, "\nThe patient number(s) is out of range\n" );
		return( 1 );
	} else {
		for ( i = 0, noSelectedPt = 0; i < len; ++i ) {
			if ( tempStr2 [ i ] == 0 ) continue;
			sscanf( tempStr2 + i, "%d", &temp );
			if ( ( tempStr2[ 0 ] == '0' ) && ( tempStr2[ 1 ] == 0 ) ) {
				fprintf ( stderr, "Completed.\n" );
				return( 0 );
			}
			if ( ( temp < 1 ) || ( temp > noTgPool[ 0 ] ) ) {
				fprintf( stderr, "\nPatient No. %d out of range\n", temp );
				return( 1 );
			}
			//	Internally the number of patients starts from 0.
			targetSt[ enum_patients ][ temp - 1 ] = 1; flag = 1; noSelectedPt++;
			//	Move to the next numeric character.
			while ( ( tempStr2[ i ] != 0 ) && ( i < len ) ) ++i;
			//	Rewind one character to adjust the counter.
			--i;
		}
	}
	// At this point, targetPt[] is correctly setup.
		
	if ( flag != 1 ) {
		return( 1 );
	}
	
	for( i = 0; i < lastChromosome - EXCLUDE_X; ++i ) {
		if( chrPosition[ i + 1 ] - chrPosition[ i ] == 0 ) {
			continue;
		}
		maxOverlapChr[ i ] = 0;
	}
	for( i = 0; i < lastChromosome - EXCLUDE_X; ++i ) {
		if( chrPosition[ i + 1 ] - chrPosition[ i ] == 0 ) {
			continue;
		}
		sprintf( outfilename, "%stempFile%03ld.txt", outputFilePath, i );
		if( NULL == ( tempFile[ i ] = fopen( outfilename, "w" ) ) ) {
			fprintf( stderr, "ERROR: Cannot open temporary file.\n" );
			exit( 1 );
		}
	}
	sprintf( tempStr1, "%sHH_RCHHsSharedBy%03u", outputFilePath, noSelectedPt );
	for( j = 0; j < noTgPool[ 0 ]; ++j ){
		//	Internally patients' number starts from 0.  Expernally it starts from 1.
		if ( targetSt[ enum_patients ][ j ] == 1 ) {
			sprintf( tempStr2, "_st%03ld", j + 1 );	
			strcat( tempStr1, tempStr2 );
		}
	}
	strcpy( tempStr2, tempStr1 );
	strcat( tempStr1, ".ps" );
	strcat( tempStr2, ".txt" );
	if( ( char * ) NULL == ( foldOverlapFileFlagTXT = ( char * ) calloc( noSelectedPt, sizeof( char ) ) ) ) { fprintf( stderr, "ERROR: Failed to allocate memory\n" ); exit ( 1 ); }
#pragma omp parallel  
{    
#pragma omp for schedule(dynamic, 1) nowait
	for( chrNo = 0; chrNo < lastChromosome - EXCLUDE_X; ++chrNo ) {
		long i2, j2;
		if( chrPosition[ chrNo + 1 ] - chrPosition[ chrNo ] == 0 ) {
			continue;
		}
		for ( i2 = chrPosition[ chrNo ]; i2 < chrPosition[ chrNo + 1 ]; ++i2 ) {
			if ( ( unsigned short int * ) NULL == ( ( sumSNP + i2 )->foldOverlap = ( unsigned short int * ) calloc ( noTgPool[ enum_patients ] + 1, sizeof ( unsigned short int ) ) ) ) { fprintf( stderr, "ERROR: Failed to allocate memory\n"); exit ( 1 ); }
			if ( ( unsigned char * ) NULL == ( sumSNP[ i2 ].expandedGType = ( unsigned char * )calloc( noTgPool[ enum_patients ] + 1, sizeof( unsigned char ) ) ) ) { fprintf( stderr, "ERROR: Cannot allocate memory.\n" ); exit( 1 ); }
			for( j2 = 0; j2 < noTgPool[ enum_patients ]; ++j2 ) {
				sumSNP[ i2 ].expandedGType[ j2 ] = getGType( sumSNP[ i2 ].gType[ enum_patients ], j2 );
			}
		}
		countRCHHSharedByMultiplePatients( enum_patients, noTgPool[ enum_patients ], chrNo, 0 );
		if( 1 == Set_up_start_end( noSelectedPt, 1, enum_patients, chrNo ) ){
			sprintf( outfilename, "%s_chr%03d", tempStr1, chrNo + 1 );
			foldOverlapFileFlagPSHeader = 0;
			Output_black_and_whitePS( outfilename, chrNo, noSelectedPt );
			sprintf( outfilename, "%s_chr%03d", tempStr2, chrNo + 1 );
			Output_foldoverlap_textHH( tempStr2, noTgPool[ enum_patients ], noSelectedPt, enum_patients, chrNo, noSelectedPt );
		}
		for ( i2 = chrPosition[ chrNo ]; i2 < chrPosition[ chrNo + 1 ]; ++i2 ) {
			free( ( sumSNP + i2 )->foldOverlap );
			free( sumSNP[ i2 ].expandedGType );
		}
	}
}
	// omp ends.
	//	MaxOverlap has the max number of patients who share RCHHs.
	for( i = 0; i < lastChromosome - EXCLUDE_X; ++i ) {
		if( chrPosition[ i + 1 ] - chrPosition[ i ] == 0 ) {
			continue;
		}
		if( maxOverlap < maxOverlapChr[ i ] ) {
			maxOverlap = maxOverlapChr[ i ];
		}
	}
	if ( maxOverlap < noSelectedPt ) {
		fprintf ( stderr, "\nNo common regions found.\n" );
		return( 1 );
	}
	free( foldOverlapFileFlagTXT );
	fprintf ( stderr, "\nCompleted.\n\n" );
	for( i = 0; i < lastChromosome - EXCLUDE_X; ++i ) {
		if( chrPosition[ i + 1 ] - chrPosition[ i ] == 0 ) {
			continue;
		}
		fclose( tempFile[ i ] );
	}
	displayHHInformation( noSelectedPt, 0 );
	for( flag = 0, i = 0; i < lastChromosome - EXCLUDE_X; ++i ) {
		sprintf( infilename, "%s_chr%03ld", tempStr1, i + 1 );
		if( NULL != ( inf = fopen( infilename, "r" ) ) ) {
			if( flag == 0 ) {
				if ( ( outf = fopen( tempStr1, "w" ) ) == NULL ) { fprintf( stderr, "ERROR: Can't output %s\n", tempStr1 ); exit( 1 ); }
				fprintf( stderr, "Writing %s\n", tempStr1 );
				fprintf( outf, "%%!PS-Adobe-3.1 EPSF-3.0\n" );
				fprintf( outf, "0 setlinewidth\n" );
				fprintf( outf, "1 setgray\n" );
				fprintf( outf, "0.02 18 scale	0 1 moveto 24572.955 0 rlineto 0 22.5 rlineto -24572.955 0 rlineto 0 1 lineto closepath stroke\n" );
				fprintf( outf, "0 setgray\n" );
				flag = 1;
			}
			while( ( char * )NULL != MyFgets( stringBuffer1, STRINGBUFFERSIZE, inf ) ) {
				fprintf( outf, "%s\n", stringBuffer1 );
			}
			fclose( inf );
			remove( infilename );
		}
	}
	if( flag == 1 ) {
		fclose( outf );
	}

	for( flag = 0, i = 0; i < lastChromosome - EXCLUDE_X; ++i ) {
		sprintf( infilename, "%s_chr%03ld", tempStr2, i + 1 );
		if( NULL != ( inf = fopen( infilename, "r" ) ) ) {
			if( flag == 0 ) {
				if ( ( outf = fopen( tempStr1, "w" ) ) == NULL ) { fprintf( stderr, "ERROR: Can't output %s\n", outfilename ); exit( 1 ); }
				flag = 1;
			}
			while( ( char * )NULL != MyFgets( stringBuffer1, STRINGBUFFERSIZE, inf ) ) {
				fprintf( outf, "%s\n", stringBuffer1 );
			}
			fclose( inf );
			remove( infilename );
		}
	}
	if( flag == 1 ) {
		fclose( outf );
	}
	return( 1 );
}
