//
//	fOutputStartEndText.c
//
//	Programming:	Koich Hagiwara
//

#include	"myHeader.h"

extern	pSummerizedSNPdata sumSNP;
extern	long	noRegions;
extern	struct	incReg	includeRegion[];
extern	int		enum_patients;
extern	int		enum_controls;
extern	int		enum_significance;

//	Output the start and the end of regions.  Floating point version.
void	fOutput_start_end_text( char *filename, char *message, int tgPool )
{
	FILE	*outf1;
	long	i, j, l, start, end;
	
	if ( ( outf1 = fopen( filename, "w" ) ) == NULL ) {
		fprintf( stderr, "\nCan't output\"%s\"\n", filename );
		exit( 1 );
	}
	//	Capable of inserting an one-line message in the first line.
	if ( strlen ( message ) != 0 )
		fprintf ( outf1, "%s\n", message );

	for( l = 0; l < noRegions; ++ l ) {	
		for ( i = includeRegion[ l ].start; i <= includeRegion[ l ].end; ++i ) {	
			if ( sumSNP[ i ].start != 1 ) {
				continue;
			}
			start = i;
			for ( j = start; j <= includeRegion[ l ].end; ++j ) {
				if ( sumSNP[ j ].end != 1 ) {
					continue;
				}
				end = j;
				break;
			}
			//	Output PostScript.
			//	enum_patient or enum_controls is for subjects.
			//	enum_sigfinicance is for the P value.
			if ( ( tgPool == enum_patients ) || ( tgPool == enum_controls ) ) {
				fprintf( outf1, "%d\t%ld\t%f\t%s\t%f\t%d\t%d\tstart\n", sumSNP[ start ].chromosome, sumSNP[ start ].position, sumSNP[ start ].genetMap, sumSNP[ start ].rsID, sumSNP[ start ].p, sumSNP[ start ].ptInvolved[ 0 ], sumSNP[ start ].ptInvolved[ 1 ] );
				fprintf( outf1, "%d\t%ld\t%f\t%s\t%f\t%d\t%d\tend\n", sumSNP[ end ].chromosome, sumSNP[ end ].position, sumSNP[ end ].genetMap, sumSNP[ end ].rsID, sumSNP[ end ].p, sumSNP[ end ].ptInvolved[ 0 ], sumSNP[ end ].ptInvolved[ 1 ] );
			} else if ( tgPool == enum_significance ) {
				fprintf( outf1, "%d\t%ld\t%f\t%s\t%f\t%d\t%d\tstart\n", sumSNP[ start ].chromosome, sumSNP[ start ].position, sumSNP[ start ].genetMap, sumSNP[ start ].rsID, sumSNP[ start ].p, sumSNP[ start ].ptInvolved[ 0 ], sumSNP[ start ].ptInvolved[ 1 ] );
				fprintf( outf1, "%d\t%ld\t%f\t%s\t%f\t%d\t%d\tend\n", sumSNP[ end ].chromosome, sumSNP[ end ].position, sumSNP[ end ].genetMap, sumSNP[ end ].rsID, sumSNP[ end ].p, sumSNP[ end ].ptInvolved[ 0 ], sumSNP[ end ].ptInvolved[ 1 ] );
			}
			i = end;
		}
	}
	fclose( outf1 );
}
