#include "myHeader.h"

extern	pSummerizedSNPdata sumSNP;
extern	struct	incReg	includeRegion[];	//	The values are set for all chromosomes even EXCLUDE_X is defined as 1. 
extern	long	noRegions;
extern	char	*outputFilePath;
extern	long	*chrPosition;
extern	char	**stFile[];
extern	int		lastChromosome;
extern	unsigned int	maxOverlap;
extern	char	stringTgPool[ 2 ][ 12 ];
extern	struct	colorBar cb[ 5 ];

void	foldOverlapDrawFigures( int tgPool, int noSubjects, int isRepresentative ) {

	long	i, j;
	long	cutoff;
	int		mode;
	float	jackup;
	char	message[ 255 ];
	char	outfilename[ 10000 ];

//
//	Output Birds_eye_view and RCHH.txt
//	SumSNP[].sum[], includeRegion[].start, includeRegion[].end, noRegions, totalAnnotationDataCount should have be set correctly.
//	
	cutoff = 0L; mode = 0;						//	For a birds eye view, cutoff is set to 0 (all data considered) and mode is set to 0 (color).
	for( i = 0; i < lastChromosome - EXCLUDE_X; ++i ) {
		Set_up_start_end( cutoff, mode, tgPool, i );	//	When the mode is 0, different values are treated as different.
	}

	jackup = JACKUP;
	for( i = 0; i < noRegions; ++ i ) {	
		for ( j = includeRegion[ i ].start; j <= includeRegion[ i ].end; ++j ) {	//	j moves within a region.
			sumSNP[ j ].color = ( float )( 1.0 - jackup - ( 1.0 - jackup ) * ( (double)sumSNP[ j ].sum[ tgPool ] ) * ( (double)sumSNP[ j ].sum[ tgPool ] ) * ( (double)sumSNP[ j ].sum[ tgPool ] ) / ( (double)maxOverlap ) / ( (double)maxOverlap ) / ( (double)maxOverlap ) );			
		}
	}
	for ( i = 0; i < 5; ++ i ) {
		cb[ i ].color = 1.0 - jackup - ( 1.0 - jackup ) * ( maxOverlap * ( 1.0 - 0.2 * i ) ) * ( maxOverlap * ( 1.0 - 0.2 * i ) ) * ( maxOverlap * ( 1.0 - 0.2 * i ) ) / maxOverlap / maxOverlap / maxOverlap;
		cb[ i ].number = maxOverlap * ( 1.0 - 0.2 * i );
	}
	if( isRepresentative == 0 ) {
		sprintf( outfilename, "%sHH_NoStSharingRCHHs_%s.ps", outputFilePath, stringTgPool[ tgPool ] );
	} else {
		sprintf( outfilename, "%sHH_NoStSharingRCHHsWithRepresentative_%s.ps", outputFilePath, stringTgPool[ tgPool ] );
	}
	Output_birds_eye_viewPS ( outfilename, tgPool );
		
	sprintf( message, "No_of_samples %d", noSubjects );
	if( isRepresentative == 0 ) {
		sprintf( outfilename, "%sHH_NoStSharingRCHHs_%s.txt", outputFilePath, stringTgPool[ tgPool ] );
	} else {
		sprintf( outfilename, "%sHH_NoStSharingRCHHsWithRepresentative_%s.txt", outputFilePath, stringTgPool[ tgPool ] );
	}
	Output_start_end_text ( outfilename, message, tgPool );
//	Output Birds_eye_view and RCHH.txt -- end.

}
