//
//	obtainRepresentativeHH.c
//
//	Programming:	Koich Hagiwara
//

#include "myHeader.h"

extern	pSummerizedSNPdata sumSNP;
extern	long	*chrPosition;
extern	long	*nEffectiveSNP[ 2 ];
extern	int		noTgPool[ 2 ];
extern	int		lastChromosome;
extern	int		enum_patients;
extern	int		enum_controls;

//	Store representative genotype to sumSNP[ enum_patients ].gType[ noPtPoot ]
void	obtainRepresentativeHH ( int chrNo )
{
	long	j, l;
	int		countA, countB;
	
	for( j = chrPosition[ chrNo ]; j < chrPosition[ chrNo + 1 ]; ++j ) {									//	j moves within a chromosome
		if ( sumSNP[ j ].sum[ enum_patients ] <= OVERLAPCUTOFF + 1 ) {
			if ( sumSNP[ j ].AFrequency < 0.5 ) {
				putGType( sumSNP[ j ].gType[ enum_patients ], noTgPool[ enum_patients ], 1 );
			} else {
				putGType( sumSNP[ j ].gType[ enum_patients ], noTgPool[ enum_patients ], 2 );
			}
		} else {
			for ( l = 0, countA = countB = 0; l < noTgPool[ enum_patients ]; ++l ) {
				if ( sumSNP[ j ].foldOverlap[ l ] >= ( sumSNP[ j ].sum[ enum_patients ] - 1 ) )	{
					if ( getGType( sumSNP[ j ].gType[ enum_patients ], l ) == 1 ) { ++countA; }
					else if ( getGType( sumSNP[ j ].gType[ enum_patients ], l ) == 2 ) { ++countB; }
				}
			}
			if ( countA > countB ) {
				putGType( sumSNP[ j ].gType[ enum_patients ], noTgPool[ enum_patients ], 1 );
			} else if( countA < countB ) {
				putGType( sumSNP[ j ].gType[ enum_patients ], noTgPool[ enum_patients ], 2 );
			} else {
				putGType( sumSNP[ j ].gType[ enum_patients ], noTgPool[ enum_patients ], 3 );
			}
		}
	}
	nEffectiveSNP[ enum_patients ][ noTgPool[ enum_patients ] * ( lastChromosome - EXCLUDE_X ) + chrNo ] = chrPosition[ chrNo + 1 ] - chrPosition[ chrNo ];
}
