//
//	otherRoutines.c
//
//	Programming:	Koich Hagiwara
//

#include	"myHeader.h"

extern long		totalAnnotationDataCount;
extern double	totalGenetDistance;
extern double	totalGenetDistanceWOX;
extern double	averageMajorAlleleFrequencyWOX;
extern long		*chrPosition;
extern pSummerizedSNPdata sumSNP;
extern	FILE	**tempFile;
extern	char	*outputFilePath;
extern	int		lastChromosome;

//	Read a line from a file and return a pointer to the string read.
//	String ends with NULL and does not contain CR or LF.  If EOF, return NULL;

//#define new
char *MyFgets(char * str, int size, FILE * stream)
#ifdef new
{
	static int stock;
	int	character, pos, lineFlag;
	
	pos = 0;
	lineFlag = 0;
	while( 1 ) {
		if( stock == 0 ) {
			character = fgetc( stream );
		} else {
			character = stock;
			stock = 0;
		}
		if( character == EOF ) {
			if( pos == 0 ) {
				str[ 0 ] = 0;
				return NULL;
			} else {
				str[ pos ] = 0;
				return str;
			}
		} else if( character == CR || character == LF ) {
			if( character == LF ) {
				str[ pos ] = 0;
				return str;
			} else {
				lineFlag = 1;
				continue;
			}
		} else {
			if( lineFlag == 1 ) {
				stock = character;
				str[ pos ] = 0;
				return str;
			} else {
				str[ pos ] = character;
				pos++;
				if( pos >= size ) {
					str[ pos ] = 0;
					return str;
				} else {
					continue;
				}
			}
		}
	}
}
#else
{
	int i, character, nextCharacter;
	
	for ( i = character = 0; i < size; ++i ){
		character = fgetc( stream ); 
		switch( character ) {
			case	EOF:
				str[ i ]=( char )0;
				if ( str[ 0 ] == 0 )
					return ( ( char * )0 );
				else
					return( str );
			case	CR:	//	Mac and Windows.
				nextCharacter = fgetc( stream );
				switch ( nextCharacter ) {
					case	EOF:
						str[ i ]=( char )0;
						if ( str[ 0 ] == 0 )
							return ( ( char * )0 );
						else
							return( str );
					case	LF:
						str[ i ] = ( char )0;
						return( str );
					default:
						ungetc( nextCharacter, stream );
						str[ i ] = ( char )0;
						return( str );
				}
			case	LF:	//	Unix
				str[ i ]=( char )0;
				return( str );
			default:
				str[ i ] = character;
				break;
		}
	}
	str[ i ]=( char )0;
	return( ( char * )0 );
}
#endif
//	Extract the file name from the file path.
char	*fileNameBody( char	*str )
{
	unsigned int	i, pos = 0;
	
	for ( i = 0; i < strlen( str ); ++ i ) {
		if ( str[ i ] == '/' ) pos = i;
	}
	if ( i == 0 ) return ( str );
	else return ( str+ pos + 1 );
}

///////////////////////// compare routines for qsort() /////////////////////////////
int	compareAnnotRsID(const void *a, const void *b)
{
	return( strcmp( ( *( ( pSummerizedSNPdata* )a ) )->rsID,  ( *( ( pSummerizedSNPdata* )b ) )->rsID ) );
}

int	comparePtRsID(const void *a, const void *b)
{
	return( strcmp( ( *( ( pSNPdata* )a )  )->rsID,  ( *( ( pSNPdata* )b ) )->rsID ) );
}

//
double	falsePositive( double thres, long nEffectiveSNPForChrNoPt1, long nEffectiveSNPForChrNoPt2, double *mean, int chrNo ) {
	
	long	n;
	double	NumHetCompSNP, a, b, l, lambda;
	double	temp;  
	double	temp2;  
	
	n = chrPosition[ chrNo + 1 ] - chrPosition [ chrNo ];			// totalAnnotationDataCount;							
	l = sumSNP[ chrPosition[ chrNo + 1 ] - 1 ].genetMap - sumSNP[ chrPosition [ chrNo ] ].genetMap;	// totalGenetDistanceWOX;
	a = averageMajorAlleleFrequencyWOX;
	b = 1.0 - averageMajorAlleleFrequencyWOX;
	
	NumHetCompSNP = 2.0 * a * a * b * b * (double)nEffectiveSNPForChrNoPt1 * (double)nEffectiveSNPForChrNoPt2 / (double)n;
	( *mean ) = l / NumHetCompSNP;
	lambda = 1.0 / ( *mean );
	
	temp2 =  exp ( - lambda * thres );
	temp = ( 1.0 + lambda * thres ) * temp2;
	return ( temp );
}

int split( char * buffer, char ** parts, char *separator, int maxNoParts )
{
	long	len, j, k, noParts, flag;
	char	*p;
	
	if ( strcmp ( separator, "," ) == 0 ) {
		len = strlen ( buffer );
		for ( j = flag = 0, k = 1, parts [ 0 ] = buffer; ( j < len ) && ( k < maxNoParts ) ; ++ j ) {
			if ( buffer [ j ] == 0 ) { break; }
			if ( buffer [ j ] == '\"' ) flag++;
			if ( ( buffer [ j ] == ',' ) && ( flag % 2 == 0 ) ) {
				buffer [ j ] = 0;
				if ( buffer [ j + 1 ] != 0 ) { parts [ k++ ] = & ( buffer [ j + 1 ] ); } else break;
			} 
		}
		parts [ k ] = NULL;
		noParts = k;
		for ( j = 0; j < k; ++ j ) {
			if ( ( ( parts [ j ] )[ 0 ] ) == '\"' ) parts [ j ] = parts [ j ] + 1;
			len = strlen ( parts [ j ] );
			if ( len != 0 ) {
				if ( parts [ j ][ len - 1 ] == '\"' ) parts [ j ][ len - 1 ] = 0;
			}
		}
		return ( ( int )noParts );
	} else {
		parts [ 0 ] = buffer; k = 0;
		while ( ( ( p = strstr ( parts [ k ], separator ) ) != NULL ) ) {
			p [ 0 ] = 0;
			if ( p [ strlen ( separator ) ] == 0 ) { parts [ ++k ] = p + strlen ( separator ); break; }
			else { 
				parts [ ++k ] = p + strlen ( separator );
				while ( ( parts [ k - 1 ] ) [ 0 ] == ' ' ) { parts [ k - 1 ] = parts [ k - 1 ] + 1; }
				while ( ( ( len = strlen ( parts [ k - 1 ] ) ) != 0 ) && ( parts [ k - 1 ] [ len - 1 ] == ' ' ) ) { parts [ k - 1 ] [ len - 1 ] = 0; }
			}
		}
		while ( ( parts [ k ] ) [ 0 ] == ' ' ) { parts [ k ] = parts [ k ] + 1; }
		while ( ( ( len = strlen ( parts [ k ] ) ) != 0 ) && ( parts [ k ] [ len - 1 ] == ' ' ) ) { parts [ k ] [ len - 1 ] = 0; }
		return ( ( int )( k + 1 ) );
	}
}

unsigned char getGType ( unsigned char *startGType, long index ) 
{
	unsigned char	gotValue, correctedValue, mask;
	unsigned long	bytePosition;
	unsigned int	residuePosition;
	
	bytePosition = ( unsigned long )index / 4;
	residuePosition = ( unsigned long )index % 4;
	if ( residuePosition == 0 ) mask = 0x3;			/* 00000011 */
	else if ( residuePosition == 1 ) mask = 0xC;	/* 00001100 */
	else if ( residuePosition == 2 ) mask = 0x30;	/* 00110000 */
	else mask = 0xC0;								/* 11000000 */
	gotValue = startGType[ bytePosition ];
	correctedValue = ( gotValue & mask ) >> ( residuePosition * 2 );
	return correctedValue;
}

void putGType ( unsigned char *startGType, long index, unsigned char value ) 
{
	unsigned char	oldValue, mask;
	unsigned long	bytePosition;
	unsigned int	residuePosition;
	
	bytePosition = ( unsigned long )index / 4;
	residuePosition = ( unsigned long )index % 4;
	if ( residuePosition == 0 ) mask = 0xFC;		/* 11111100 */
	else if ( residuePosition == 1 ) mask = 0xF3;	/* 11110011 */
	else if ( residuePosition == 2 ) mask = 0xCF;	/* 11001111 */
	else mask = 0x3F;								/* 00111111 */
	oldValue = startGType[ bytePosition ];
	if ( value == 1 || value == 2 || value == 3 ) {
		startGType[ bytePosition ] = ( oldValue & mask ) + ( value << ( residuePosition * 2 ) );
	} else {
		startGType[ bytePosition ] = ( oldValue & mask );
	}
}

void displayHHInformation( int noSt, int isRepresentative ) {
	int		noCombination;
	int		i, j;
	char	filename1[ 10000 ];
	char	stringBuffer1[ STRINGBUFFERSIZE ];
	int		noParts;
	char	**parts;
	double	totalGeneticLength;
	
	struct HHInfo {
		char	**header;
		char	cutoff[ 255 ];
		char	**fileName1;
		char	**fileName2;
		double	*cMconserved;
		long	*noSNPPt1;
		long	*noSNPPt2;
		double	*typeAFP;
		double	*typeBFP;
	};
	struct HHInfo info;
	
	if( isRepresentative == 0 ) {
		noCombination = noSt * ( noSt - 1 ) / 2;
	} else {
		noCombination = noSt;
	}
	info.header = ( char ** )calloc( noCombination, sizeof ( char* ) );
	info.fileName1 = ( char ** )calloc( noCombination, sizeof ( char* ) );
	info.fileName2 = ( char ** )calloc( noCombination, sizeof ( char* ) );
	info.cMconserved = ( double * )calloc( noCombination, sizeof ( double ) );
	info.noSNPPt1 = ( long * )calloc( noCombination, sizeof( long ) );
	info.noSNPPt2 = ( long * )calloc( noCombination, sizeof( long ) );
	info.typeAFP = ( double * )calloc( noCombination, sizeof ( double ) );
	info.typeBFP = ( double * )calloc( noCombination, sizeof ( double ) );
	for( i =0; i < noCombination; ++i ) {
		info.header[ i ] = ( char * )malloc( 255 );
		info.fileName1[ i ] = ( char * )malloc( 255 );
		info.fileName2[ i ] = ( char * )malloc( 255 );
	}
	if ( ( char ** ) NULL == ( parts = ( char ** ) calloc ( MAX_NUMBER_OF_PARTS, sizeof ( char * ) ) ) ) { fprintf( stderr, "ERROR: Failed to allocate memory\n"); exit ( 1 ); }
	
	for( i = 0; i < lastChromosome - EXCLUDE_X; ++i ) {
		if( chrPosition[ i + 1 ] - chrPosition[ i ] == 0 ) {
			continue;
		}
		sprintf( filename1, "%stempFile%03d.txt", outputFilePath, i );
		tempFile[ i ] = fopen( filename1, "r" );
	}
	
	fprintf ( stderr, "( St1, St2 )\t\'Cutoff(cM)\'\t\'File names\'\t\t\'cM conserved\'\t \'Ratio\'\t\'No. SNP St1\'\t\'No. SNP St2\'\t\'Type A FP\'\t\'Type B FP\'\n" );
	
	for( j = 0; j < lastChromosome - EXCLUDE_X; ++j ) {
		if( chrPosition[ j + 1 ] - chrPosition[ j ] == 0 ) {
			continue;
		}
		sprintf( filename1, "%stempFile%03d.txt", outputFilePath, j );
		for( i = 0; i < noCombination; ++i ) {
			if( ( char * )NULL == MyFgets( stringBuffer1, STRINGBUFFERSIZE, tempFile[ j ] ) ) {
				fprintf( stderr, "ERROR: Inappropriate temporary file.\n" );
				exit( 1 );
			}
			noParts = split( stringBuffer1, parts, "\t", MAX_NUMBER_OF_PARTS );
			if( i == 0 ) {
				strcpy( info.cutoff, parts[ 1 ] );
			}
			strcpy( info.header[ i ], parts[ 0 ] );
			strcpy( info.fileName1[ i ], parts[ 2 ] );
			strcpy( info.fileName2[ i ], parts[ 3 ] );
			info.cMconserved[ i ] += atof( parts[ 4 ] );
			info.noSNPPt1[ i ] += atol( parts[ 6 ] );
			info.noSNPPt2[ i ] += atol( parts[ 7 ] );
			info.typeAFP[ i ] += atof( parts[ 8 ] ) * ( sumSNP[ chrPosition[ j + 1 ] - 1 ].genetMap - sumSNP[ chrPosition[ j ] ].genetMap );
			info.typeBFP[ i ] += atof( parts[ 9 ] ) * ( sumSNP[ chrPosition[ j + 1 ] - 1 ].genetMap - sumSNP[ chrPosition[ j ] ].genetMap );
		}
	}
	for( i = 0; i < lastChromosome - EXCLUDE_X; ++i ) {
		if( chrPosition[ i + 1 ] - chrPosition[ i ] == 0 ) {
			continue;
		}
		fclose( tempFile[ i ] );
	}
	for( i = 0, totalGeneticLength = 0.0; i < lastChromosome - EXCLUDE_X; ++i ) {
		if( chrPosition[ i + 1 ] != chrPosition[ i ] ) {
			totalGeneticLength += ( sumSNP[ chrPosition[ i + 1 ] - 1 ].genetMap - sumSNP[ chrPosition[ i ] ].genetMap );
		}
	}
	for( i = 0; i < noCombination; ++i ) {
		fprintf( stderr, "%s\t%s\t%s\t%s\t%.1f\t%.3f\t%ld\t%ld\t%.3f\t%.3f\n", info.header[ i ], info.cutoff, info.fileName1[ i ], info.fileName2[ i ], info.cMconserved[ i ], info.cMconserved[ i ] / totalGeneticLength, info.noSNPPt1[ i ], info.noSNPPt2[ i ], info.typeAFP[ i ] / ( ( EXCLUDE_X == 0 )? totalGenetDistance: totalGenetDistanceWOX ), info.typeBFP[ i ] / ( ( EXCLUDE_X == 0 )? totalGenetDistance: totalGenetDistanceWOX ) );
	}
	for( i = 0; i < noCombination; ++i ) {
		free( info.header[ i ] );
		free( info.fileName1[ i ] );
		free( info.fileName2[ i ] );
	}
	free( info.header );
	free( info.fileName1 );
	free( info.fileName2 );
	free( info.noSNPPt1 );
	free( info.noSNPPt2 );
	free( info.cMconserved );
}
