//
//	outputBirdsEyeViewPS.c
//
//	Programming:	Koich Hagiwara
//

#include	"myHeader.h"

extern	pSummerizedSNPdata sumSNP;
extern  struct	incReg	includeRegion[10000];
extern	long	noRegions;
extern	long	*chrPosition;
extern	struct	colorBar cb[];
extern	int	enum_significance;

//	Output chromosome figure in colors.
void	Output_birds_eye_viewPS ( char *filename, int tgPool )
{
	FILE	*outf;
	long	i, j, l, start, end;
	int		k;
	double	color1, color2, color3;
	
	if ( ( outf = fopen( filename, "w") ) == NULL ) {
		fprintf( stderr, "ERROR: Can't output\"%s\"\n", filename );
		exit( 1 );
	} 
	fprintf( outf, "%%!PS-Adobe-3.1 EPSF-3.0\n" );
	if ( tgPool == enum_significance ) {
		fprintf( outf, "/Helvetica findfont 4 scalefont setfont gsave 2.83 2.83 scale \n" );
		for ( k = 0; k < 5; ++ k ) {
			fprintf( outf, "%d %d moveto 5 0 rlineto 0 5 rlineto -5 0 rlineto closepath ", 150, 105 - k * 5 );
			if ( cb[ k ].color < 0.33 ) { color1 = 0.0; color2 = 0.0; color3 = 3 * cb[ k ].color; } 
			else if ( cb[ k ].color < 0.67 ) { color1 = 0.0; color2 = 3 * ( cb[ k ].color - 0.33 ) ; color3 = 1.0; }
			else { color1 = 3 * ( cb[ k ].color - 0.67 ); color2 = 1.0; color3 = 1.0; }
			fprintf( outf, "%lf %lf %lf setrgbcolor fill ", color1, color2, color3 );
			fprintf( outf, "0 0 0 setrgbcolor %f %f moveto (%.2f) show\n", 157.0, ( float )( 106.5 - k * 5 ), cb[ k ].number );
		}
		fprintf( outf, "grestore\n" );
	}
	fprintf( outf, "0 setlinewidth\n" );
	fprintf( outf, "1 setgray\n" );
	fprintf( outf, "0.02 18 scale	0 1 moveto 24572.955 0 rlineto 0 22.5 rlineto -24572.955 0 rlineto 0 1 lineto closepath stroke\n" );
	
	for ( l = 0; l < noRegions; ++l ) {
		for ( i = includeRegion[ l ].start; i <= includeRegion[ l ].end; i++ ) {
			if ( sumSNP[ i ].start != 1 ) {
				continue;
			}
			start = i;
			for ( j = start; j <= includeRegion[ l ].end; ++j ) {
				if ( sumSNP[ j ].end != 1 ) {
					continue;
				}
				end = j;
				break;
			}

			if ( sumSNP[ start ].color < 0.33 ) { color1 = 0.0; color2 = 0.0; color3 = 3 * sumSNP[ start ].color; } 
			else if ( sumSNP[ start ].color < 0.67 ) { color1 = 0.0; color2 = 3 * ( sumSNP[ start ].color - 0.33 ) ; color3 = 1.0; }
			else { color1 = 3 * ( sumSNP[ start ].color - 0.67 ); color2 = 1.0; color3 = 1.0; }
		
			fprintf( outf, "%f %f %f setrgbcolor\n", color1, color2, color3);
#ifdef		SHORT
			fprintf( outf, "%d\t%f\texch 1 sub 0.75 mul 1 add moveto 0 0.5 rlineto\t%%%%%s\tstart\t%ld\n", sumSNP[ start ].chromosome, sumSNP[ start ].position / 10000.0, sumSNP[ start ].rsID, sumSNP[ start ].recordNo );
			fprintf( outf, "%d\t%f\texch 1 sub 0.75 mul 1.5 add lineto 0 -0.5 rlineto closepath fill\t%%%%%s\tend\n", sumSNP[ end ].chromosome,sumSNP[ end ].position / 10000.0,sumSNP[ end ].rsID );
#else
			fprintf( outf, "%d\t%f\texch moveto 0 0.5 rlineto\t%%%%%s\tstart\t%ld\n", sumSNP[ start ].chromosome, sumSNP[ start ].position / 10000.0, sumSNP[ start ].rsID, sumSNP[ start ].recordNo );
			fprintf( outf, "%d\t%f\texch 0.5 add lineto 0 -0.5 rlineto closepath fill\t%%%%%s\tend\n", sumSNP[ end ].chromosome, sumSNP[ end ].position / 10000.0, sumSNP[ end ].rsID );
#endif
			i = end;
		}
	}
	fclose( outf );
}
