//
//	outputBlackAndWhite.c
//
//	Programming:	Koich Hagiwara
//

#include	"myHeader.h"

extern  pSummerizedSNPdata sumSNP;
extern  struct	incReg	includeRegion[10000];
extern	long	noRegions;
extern	long	*chrPosition;
extern	char	foldOverlapFileFlagPSHeader;
extern	char	*foldOverlapFileFlagTXT;

//	Output chromosome figure in black and white.
void	Output_black_and_whitePS ( char *filename, int chrNo, int foldOverlap )
{
	FILE	*outf;
	long	i, j, l, start, end;

	if ( ( outf = fopen( filename, "w" ) ) == NULL ) {
		fprintf( stderr, "ERROR: Can't output\"%s\"\n", filename );
		exit( 1 );
	} 
	if( foldOverlapFileFlagPSHeader == 1 ) {
		fprintf( outf, "%%!PS-Adobe-3.1 EPSF-3.0\n" );
		fprintf( outf, "0 setlinewidth\n" );
		fprintf( outf, "1 setgray\n" );
		fprintf( outf, "0.02 18 scale	0 1 moveto 24572.955 0 rlineto 0 22.5 rlineto -24572.955 0 rlineto 0 1 lineto closepath stroke\n" );
		fprintf( outf, "0 setgray\n" );
	}
	
	for ( l = 0; l < noRegions; ++l ) {
		if( chrPosition[ chrNo ] <= includeRegion[ l ].start && includeRegion[ l ].end < chrPosition[ chrNo + 1 ] ) {
			for ( i = includeRegion[ l ].start; i <= includeRegion[ l ].end; i++ ) {
				if ( sumSNP[ i ].start != 1 ) {
					continue;
				}
				start = i;
				for ( j = start; j <= includeRegion[ l ].end; ++j ) {
					if ( sumSNP[ j ].end != 1 ) {
						continue;
					}
					end = j;
					break;
				}
				
#ifdef		SHORT
				fprintf( outf, "%d\t%f\texch 1 sub 0.75 mul 1 add moveto 0 0.5 rlineto\t%%%%%s\tstart\t%ld\n",sumSNP[start].chromosome,sumSNP[start].position / 10000.0, sumSNP[start].rsID, sumSNP[start].recordNo);
				fprintf( outf, "%d\t%f\texch 1 sub 0.75 mul 1.5 add lineto 0 -0.5 rlineto closepath fill\t%%%%%s\tend\n",sumSNP[end].chromosome,sumSNP[end].position / 10000.0, sumSNP[end].rsID);
#else
				fprintf( outf, "%d\t%f\texch moveto 0 0.5 rlineto\t%%%%%s\tstart\t%ld\n",sumSNP[start].chromosome, sumSNP[start].position / 10000.0,sumSNP[start].rsID, sumSNP[start].recordNo);
				fprintf( outf, "%d\t%f\texch 0.5 add lineto 0 -0.5 rlineto closepath fill\t%%%%%s\tend\n",sumSNP[end].chromosome, sumSNP[end].position / 10000.0,sumSNP[end].rsID);
#endif
				i = end;
			}
		}
	}
	fclose(outf);
}
