//
//	outputFoldOverlapTextHH.c
//
//	Programming:	Koich Hagiwara
//

#include	"myHeader.h"

extern	pSummerizedSNPdata sumSNP;
extern	long	noRegions;
extern	struct	incReg	includeRegion[ 10000 ];
extern	char	**stFile[];
extern	long	*chrPosition;
extern	char	*foldOverlapFileFlagTXT;

void	Output_foldoverlap_textHH ( char *filename, int noSubjects, long cutoff, int tgPool, int chrNo, int foldOverlap )
{
	FILE	*outf;
	long	i, j, k, l, start, end;
	
	if( foldOverlapFileFlagTXT[ foldOverlap ] == 0 ) {
		if ( ( outf = fopen( filename, "w" ) ) == NULL ) {
			fprintf( stderr, "ERROR: Can't output\"%s\"\n", filename );
			exit( 1 );
		} 
		foldOverlapFileFlagTXT[ foldOverlap ] = 1;
	} else {
		outf = fopen( filename, "a" );
	}
	for( l = 0; l < noRegions; ++ l ) {	
		if( chrPosition[ chrNo ] <= includeRegion[ l ].start && includeRegion[ l ].end < chrPosition[ chrNo + 1 ] ) {
			for ( i = includeRegion[ l ].start; i <= includeRegion[ l ].end; ++i ) {
				if ( sumSNP[ i ].start != 1 ) {
					continue;
				}
				start = i;
				for ( j = start; j <= includeRegion[ l ].end; ++j ) {
					if ( sumSNP[ j ].end != 1 ) {
						continue;
					}
					end = j;
					break;
				}
				fprintf( outf, "%d\t%ld\t%f\t%s\tstart\tSubjects\t", sumSNP[ start ].chromosome, sumSNP[ start ].position, sumSNP[ start ].genetMap, sumSNP[ start ].rsID );
				//	Internally, when sumSNP[].foldOverlap is 3, it means that the number of patients involving this overlap is 4.
				//	Patients' number starts from 1 when displayed.  Starts from 1 internally.
				for ( k = 0 ; k < noSubjects ; ++k ) {
					if ( sumSNP[ start ].foldOverlap[ k ]  >= cutoff - 1 ) {
						fprintf( outf, " %s", fileNameBody( stFile[ tgPool ][ k ] ) );
					}
				}
				fprintf( outf, "\n" );
				fprintf( outf, "%d\t%ld\t%f\t%s\tend\tSubjects\t", sumSNP[ end ].chromosome, sumSNP[ end ].position, sumSNP[ end ].genetMap, sumSNP[ end ].rsID );
				//	Internally, when sumSNP[].foldOverlap is 3, it means that the number of patients involving this overlap is 4.
				//	Patients' number starts from 1 when displayed.  Starts from 1 internally.
				for ( k = 0 ; k < noSubjects ; ++k ) {
					if ( sumSNP[ end ].foldOverlap[ k ] >= cutoff - 1 ) {
						fprintf( outf, " %s", fileNameBody( stFile[ tgPool ][ k ] ) );
					}
				}
				fprintf( outf, "\n" );
				i = end;
			}
		}
	}
	fclose( outf );
}
