//
//	outputStartEndText.c
//
//	Programming:	Koich Hagiwara
//

#include	"myHeader.h"

extern	pSummerizedSNPdata sumSNP;
extern	long	noRegions;
extern	struct	incReg	includeRegion[10000];

//	Output the start and the end of regions.
void	Output_start_end_text ( char *filename, char *message, int tgPool )
{
	FILE	*outf1;
	long	i, j, l, start, end;
	
	if ( ( outf1 = fopen( filename, "w" ) ) == NULL ) {
		fprintf( stderr, "ERROR: Can't output\"%s\"\n", filename );
		exit( 1 );
	} 
	//	Capable of inserting an one-line message in the first line.
	if ( strlen ( message ) != 0 )
		fprintf ( outf1, "%s\n", message );

	for( l = 0; l < noRegions; ++ l ) {												
		for ( i = includeRegion[ l ].start; i <= includeRegion[ l ].end; ++i ) {		
			if ( sumSNP[ i ].start != 1 ) {
				continue;
			}
			start = i;
			for ( j = start; j <= includeRegion[ l ].end; ++j ) {					
				if ( sumSNP[ j ].end != 1 ) {
					continue;
				}
				end = j;
				break;
			}
			//	Output PostScript.
			//	enum_patient or enum_controls is for subjects.
			//	enum_sigfinicance is for the P value.
			fprintf( outf1, "%d\t%ld\t%f\t%s\t%ld\tstart\n", sumSNP[ start ].chromosome, sumSNP[ start ].position, sumSNP[ start ].genetMap, sumSNP[ start ].rsID, sumSNP[ start ].sum[ tgPool ] );
			fprintf( outf1, "%d\t%ld\t%f\t%s\t%ld\tend\n", sumSNP[ end ].chromosome, sumSNP[ end ].position, sumSNP[ end ].genetMap, sumSNP[ end ].rsID, sumSNP[ end ].sum[ tgPool ] );
			i = end;
		}
	}
	fclose( outf1 );
}
