//
//	readAnalysisFile.c
//
//	Programming:	Koich Hagiwara
//

#include	"myHeader.h"

extern	char	*annotationFilePath;
extern	char	*exclusionFilePath;
extern	char	*targetFilePath;
extern	char	*outputFilePath;
extern	int		noTgPool[ 2 ];
extern	char	**stFile[];
extern	int		enum_patients;
extern	int		enum_controls;
extern	long	largeGap;

void	readAnalysisFile ( char *filename ) {
	FILE	*infilename, *infilename2, *outfilename;
	char	str[STRINGBUFFERSIZE];
	char	tempStr[STRINGBUFFERSIZE];
	int		i;
	char	*p;

	if ( NULL == ( infilename = fopen ( filename, "r" ) ) )  {
		fprintf( stderr, "ERROR: Analysis file is not found.\n" );
		exit( 1 );
	}

	//	Annotation file
	infilename = fopen ( filename, "r" );
	while ( ( p = MyFgets( str, STRINGBUFFERSIZE, infilename ) ) != NULL ) {
		if ( 0 == strncmp( "::annotation file", str, 17 ) ) {
			break;
		}
	}																				//	continue.
	if ( p == NULL ) {															//	If EOF
		fprintf( stderr, "ERROR: '::annotation file' label is not found.\n" );				//	output a message and exit.
		exit( 1 );
	}
	while( MyFgets( str, STRINGBUFFERSIZE, infilename ) != NULL && str[ 0 ] != ':' ) {	// EOF or ":"
		p = strip( str );
		if( p[ 0 ] == 0 ) continue;
		else goto labelAnnotation;
	}
	fprintf( stderr, "ERROR: Annotation file is not set.\n" );
	exit( 1 );

labelAnnotation:
	fclose( infilename );
	annotationFilePath = ( char *)malloc( strlen( p ) + 1 );
	strcpy( annotationFilePath, p );										//	else store to annotation path
	if ( NULL == ( infilename2 = fopen ( annotationFilePath, "r" ) ) ) {			//	if annotation file is not found
		fprintf( stderr, "ERROR: Cannot open annotation file.\n" );							//	output a message and exit.
		exit( 1 );
	} else {
		fprintf( stderr, "Annotation file:\t%s\n", annotationFilePath );			//	output a message and exit.
		fclose( infilename2 );
	}

	//	Exclusion file
	infilename = fopen ( filename, "r" );
	while ( ( p = MyFgets( str, STRINGBUFFERSIZE, infilename ) ) != NULL ) {
		if ( 0 == strncmp( "::excluded area file", str, 18 ) ) {
			break;
		}
	}
	if ( p == NULL ) {															//	If EOF
		fprintf( stderr, "ERROR: '::Excluded area file' label is not found.\n" );		//	output a message and exit.
		exit( 1 );
	}
	while( MyFgets( str, STRINGBUFFERSIZE, infilename ) != NULL && str[ 0 ] != ':' ) {
		p = strip( str );
		if( p[ 0 ] == 0 ) continue;
		else goto labelExclusionFileIsSet;
	}
	fprintf( stderr, "Excluded area file is not set.\n" );
	fclose( infilename );
	exclusionFilePath = ( char *)malloc( 1 );
	exclusionFilePath[ 0 ] = 0;
	goto labelExclusionFileJoin;
	
labelExclusionFileIsSet:
	fclose( infilename );
	exclusionFilePath = ( char *)malloc( strlen( p ) + 1 );
	strcpy( exclusionFilePath, p );
	targetFilePath = ( char *)malloc( 1 );
	targetFilePath[ 0 ] = 0;
	if ( NULL == ( infilename2 = fopen ( exclusionFilePath, "r" ) ) ) {			//	if annotation file is not found
		fprintf( stderr, "ERROR: Cannot open excluded area file.\n" );						//	output a message and exit.
		exit( 1 );
	} else {
		fprintf( stderr, "Excluded area file:\t%s\n", exclusionFilePath );		//	output a message and exit.
		fclose( infilename2 );
	}
	
labelExclusionFileJoin:

//	Target file
	// If excluded area file is not set
	if( exclusionFilePath[ 0 ] == 0 ) {
		infilename = fopen ( filename, "r" );
		while ( ( p = MyFgets( str, STRINGBUFFERSIZE, infilename ) ) != NULL ) {
			if ( 0 == strncmp( "::target area file", str, 16 ) ) {
				break;
			}
		}
		if ( p == NULL ) {//	If EOF
			// For backward compatibility.
			fprintf( stderr, "Target area file is not set.\n" );
			targetFilePath = ( char *)malloc( 1 );
			targetFilePath[ 0 ] = 0;
			goto labelTargetFileJoin;
//			fprintf( stderr, "ERROR: '::Target area file' label is not found.\n" );		//	output a message and exit.
//			exit( 1 );
		}
		while( MyFgets( str, STRINGBUFFERSIZE, infilename ) != NULL && str[ 0 ] != ':' ) {
			p = strip( str );
			if( p[ 0 ] == 0 ) continue;
			else goto labelTargetFileIsSet;
		}
		fprintf( stderr, "Target area file is not set.\n" );
		fclose( infilename );
		targetFilePath = ( char *)malloc( 1 );
		targetFilePath[ 0 ] = 0;
		goto labelTargetFileJoin;
		
	labelTargetFileIsSet:
		fclose( infilename );
		targetFilePath = ( char *)malloc( strlen( p ) + 1 );
		strcpy( targetFilePath, p );
		if ( NULL == ( infilename2 = fopen ( targetFilePath, "r" ) ) ) {			//	if annotation file is not found
			fprintf( stderr, "ERROR: Cannot open target area file.\n" );						//	output a message and exit.
			exit( 1 );
		} else {
			fprintf( stderr, "Target area file:\t%s\n", targetFilePath );		//	output a message and exit.
			fclose( infilename2 );
		}
	}
labelTargetFileJoin:
	
	//	Patient pool
	infilename = fopen ( filename, "r" );
	while ( ( p = MyFgets( str, STRINGBUFFERSIZE, infilename ) ) != NULL ) {
		if ( 0 == strncmp( "::patient pool", str, 14 ) ) {
			break;
		}
	}
	if ( p == NULL ) {														//	If EOF
		fprintf( stderr, "ERROR: '::Patient pool' label is not found.\n" );		//	output a message and exit.
		exit( 1 );
	}
	i = 0;
	while ( MyFgets( str, STRINGBUFFERSIZE, infilename ) != NULL && str[ 0 ] != ':' ) {
		p = strip( str );
		if( p[ 0 ] != 0 ) {
			i++;
		}
	}
	if ( i == 0 ) {															//	If EOF
		fprintf( stderr, "ERROR: Patient pool is not set.\n" );					//	output a message and exit.
		exit( 1 );
	}
	noTgPool[ 0 ] = i;
	fclose( infilename );

	if ( ( char ** ) NULL == ( stFile[ enum_patients ] = ( char ** ) calloc ( noTgPool[ 0 ], sizeof ( char * ) ) ) ) { fprintf( stderr, "ERROR: Failed to allocate memory.\n" ); exit ( 1 ); }
	//	Store the file names for the patient pool.
	infilename = fopen ( filename, "r" );
	while ( ( p = MyFgets( str, STRINGBUFFERSIZE, infilename ) ) != NULL ) {
		if ( 0 == strncmp( "::patient pool", str, 14 ) ) {
			break;
		}
	}
	i = 0;
	while ( MyFgets( str, STRINGBUFFERSIZE, infilename ) != NULL && str[ 0 ] != ':' ) {
		p = strip( str );
		if( p[ 0 ] != 0 ) {
			stFile[ enum_patients ][ i ] = ( char *)malloc( strlen( p ) + 1 );
			strcpy( stFile[ enum_patients ][ i ], p );
			i++;
		}
	}
	fclose( infilename );
	
	for ( i = 0; i < noTgPool[ 0 ]; ++i ) {
		if ( NULL == ( infilename = fopen ( stFile[ enum_patients ][ i ], "r" ) ) ) {
			fprintf( stderr, "ERROR: Patient file %s is not found.\n", stFile[ enum_patients ][ i ] );
			exit( 1 );	
		} else {
			fclose( infilename );
		}
	}
	fprintf( stderr, "Patient pool:	a total of %d patients\n", noTgPool[ 0 ] );	
	for ( i = 0; i < noTgPool[ 0 ]; ++i ) {
		fprintf( stderr, "\t%s\n", stFile[ enum_patients ][ i ] );	
	}
	
//	Control pool
	infilename = fopen ( filename, "r" );
	while ( ( p = MyFgets( str, STRINGBUFFERSIZE, infilename ) ) != NULL ) {
		if ( 0 == strncmp( "::control pool", str, 14 ) ) {
			break;
		}
	}
	if ( p == NULL ) {														//	If EOF
		fprintf( stderr, "ERROR: '::Control pool' label is not found.\n" );		//	output a message and exit.
		exit( 1 );
	}
	i = 0;
	while( MyFgets( str, STRINGBUFFERSIZE, infilename ) != NULL ) {
		if( str[ 0 ] == ':' ) break;
		p = strip( str );
		if( p[ 0 ] != 0 ) { i++; }
	}
	if( i == 0 ) {
		fprintf( stderr, "Control pool is not used.\n" );						//	output a message and exit.
	}
	noTgPool[ 1 ] = i;
	fclose( infilename );
	
	if( noTgPool[ 1 ] != 0 ) {
		if ( ( char ** ) NULL == ( stFile[ enum_controls ] = ( char ** ) calloc ( noTgPool[ 1 ], sizeof ( char * ) ) ) ) { fprintf( stderr, "ERROR: Failed to allocate memory\n"); exit ( 1 ); }
	}
	
	infilename = fopen ( filename, "r" );
	while ( MyFgets( str, STRINGBUFFERSIZE, infilename ) ) {
		if ( 0 == strncmp( "::control pool", str, 14 ) )  
			break;
	}																				//	continue.
	i = 0;
	while ( MyFgets( str, STRINGBUFFERSIZE, infilename ) != NULL && str[ 0 ] != ':' ) {
		p = strip( str );
		if( p[ 0 ] != 0 ) {
			stFile[ enum_controls ][ i ] = ( char *)malloc( strlen( p ) + 1 );
			strcpy( stFile[ enum_controls ][ i ], p );
			i++;
		}
	}
	fclose( infilename );
	
	if ( noTgPool[ 1 ] != 0 ) {
		for ( i = 0; i < noTgPool[ 1 ]; ++i ) {
			if ( NULL == ( infilename = fopen ( stFile[ enum_controls ][ i ], "r" ) ) ) {
				fprintf( stderr, "ERROR: Control file %s is not found.\n", stFile[ enum_controls ][ i ] );
				exit( 1 );	
			} else {
				fclose( infilename );
			}
		}
		fprintf( stderr, "Control pool:\ta total of %d subjects\n", noTgPool[ 1 ] );	
		for ( i = 0; i < noTgPool[ 1 ]; ++i ) {
			fprintf( stderr, "\t%s\n", stFile[ enum_controls ][ i ] );	
		}
	}
	
//	Output path
	infilename = fopen ( filename, "r" );
	while ( ( p = MyFgets( str, STRINGBUFFERSIZE, infilename ) ) != NULL ) {
		if ( 0 == strncmp( "::output directory", str, 18 ) ) {
			break;
		}
	}
	if ( p == NULL ) {														//	If EOF
		fprintf( stderr, "ERROR: Output director label is not found.\n" );							//	output a message and exit.
		exit( 1 );
	}
	while( MyFgets( str, STRINGBUFFERSIZE, infilename ) != NULL && str[ 0 ] != ':' ) {
		p = strip( str );
		if( p[ 0 ] == 0 ) continue;
		else goto labelOutputDirectoryIsSet;
	}
	fprintf( stderr, "ERROR: Output directory is not set.\n" );
	fclose( infilename );
	exit( 1 );

labelOutputDirectoryIsSet:
	outputFilePath = ( char *)malloc( strlen( p ) + 1 );
	strcpy( outputFilePath, p );
	strcpy( tempStr, outputFilePath );
	strcat( tempStr, "____temp____" );
	if ( NULL == ( outfilename = fopen ( tempStr, "w" ) ) ) {
		fprintf( stderr, "ERROR: Output directory does not exist.\n" );						//	output a message and exit.
		exit( 1 );
	} else {
		fprintf( stderr, "Output directory:\t%s\n", outputFilePath );				//	output a message and exit.
		fclose( outfilename );
		remove( tempStr );
	}

//	Large gap
	infilename = fopen ( filename, "r" );
	while ( ( p = MyFgets( str, STRINGBUFFERSIZE, infilename ) ) != NULL ) {
		if ( 0 == strncmp( "::use large gap", str, 15 ) ) {
			break;
		}
	}
	if ( p == NULL ) {														//	If EOF
		largeGap = LARGEGAP;
		return;
	}
	if( ( p = MyFgets( str, STRINGBUFFERSIZE, infilename ) ) != NULL ) {
		if ( 0 == strncmp( "NO", str, 2 ) ) {
			largeGap = 900000000L;
		} else {
			largeGap = LARGEGAP;
		}
	}
	return;
}

char *strip( char *str ) {
	char *s;
	
	if( str == NULL ) return NULL;
	s = str;
	while( s[ 0 ] == ' ' || s[ 0 ] == '\t' ) {
		s++;
	}
	while( s[ strlen( s ) - 1 ] == ' ' || s[ strlen( s ) - 1 ] == '\t' ) {
		s[ strlen( s ) - 1 ] = 0;
	}
	return s;
}
