//
//	readGenetyping.c
//
//	Programming:	Koich Hagiwara
//

#include "myHeader.h"
extern	pSummerizedSNPdata sumSNP;
extern	pSummerizedSNPdata* pASNP;
extern	pSNPdata SNP;
extern	pSNPdata* pDSNP;
extern	long	totalAnnotationDataCount;
extern	char	**stFile[];
extern	long	*nEffectiveSNP[ 2 ];
extern	int		lastChromosome;

void	readGenotypingData ( int tgPool, int noSubjects ) {

	long	i, j, k, maxLineNumber, lineNumber;
	int		temp;
	long	AAtype, BBtype, ABtype;
	long	patientDataNo;
	FILE	*inf;
	char	stringBuffer1[ STRINGBUFFERSIZE ];
	long	aData, failed;
	//	temporality storage for patient's data.
	int		noParts;
	char	**parts;
	int		oldversion;
	int		genotypeColumnNumber, rsColumnNumber;
	
	if ( ( char ** ) NULL == ( parts = ( char ** ) calloc ( MAX_NUMBER_OF_PARTS, sizeof ( char * ) ) ) ) { fprintf( stderr, "ERROR: Failed to allocate memory\n"); exit ( 1 ); }
	
	//  Initialize sumSNP[].patientHap[][] (storage of the HH) and sumSNP[].type[][] (storage of the genotype).
/*
	for( j = 0; j < noSubjects; ++j ) {
		for ( i = 0; i < totalAnnotationDataCount; ++i ) {
			sumSNP[ i ].patientHap[ tgPool ][ j ] = 0;
			sumSNP[ i ].gType[ tgPool ][ j ] = 0;
		}
	}
*/
	for( j = 0; j <= ( noSubjects - 1 ) / 4; ++j ) {
		for ( i = 0; i < totalAnnotationDataCount; ++i ) {
			sumSNP[ i ].gType[ tgPool ][ j ] = 0;
		}
	}
	
	maxLineNumber = 0;
	lineNumber = 0;
	inf = fopen( stFile[ tgPool ][ 0 ], "r" );
	while ( ( char * )NULL != MyFgets( stringBuffer1, STRINGBUFFERSIZE, inf ) ) {
		lineNumber++;
	}
	fclose( inf );
	maxLineNumber = ( long )( lineNumber * 1.2 );
	j = 0;
	
moreMemory:
	if ( ( pSNPdata ) NULL == ( SNP = ( pSNPdata ) calloc ( maxLineNumber, sizeof( struct SNPdata ) ) ) )  { fprintf( stderr, "ERROR: Failed to allocate memory\n"); exit ( 1 ); }
	if ( ( pSNPdata * ) NULL == ( pDSNP = ( pSNPdata * ) calloc ( maxLineNumber, sizeof( pSNPdata ) ) ) )  { fprintf( stderr, "ERROR: Failed to allocate memory\n"); exit ( 1 ); }

	fprintf( stderr, "\n%.2f MegaBytes were allocated for reading genotyping data.\n", maxLineNumber * sizeof( struct SNPdata ) / 1000.0 / 1000.0 );
	
	for( ; j < noSubjects; ++j ) {	
		//	Open files containing patients' genotyping data.
		inf = fopen( stFile[ tgPool ][ j ], "r" );
		MyFgets( stringBuffer1, STRINGBUFFERSIZE, inf );
		noParts = split( stringBuffer1, parts, "\t", MAX_NUMBER_OF_PARTS );
		temp = 0;
		for( i = 0; i < ( long )( strlen( parts[ 0 ] ) ); ++i ) {
			if ( parts[ 0 ][ i ] < '0' || parts[ 0 ][ i ] > '9' ) {
				temp = 1; break;
			}
		}
		if( temp == 0 ) {
			oldversion = 1;
			genotypeColumnNumber = 2; rsColumnNumber = 4;
		} else {
			oldversion = 0;
			genotypeColumnNumber = 1; rsColumnNumber = 0;
		}
		fclose ( inf );
		
		inf = fopen( stFile[ tgPool ][ j ], "r" );
		
		patientDataNo = 0;
		AAtype = BBtype = ABtype = 0;
		//	Read each field.
		while ( ( char * )NULL != MyFgets( stringBuffer1, STRINGBUFFERSIZE, inf ) ) {
			noParts = split( stringBuffer1, parts, "\t", MAX_NUMBER_OF_PARTS );
			if ( ( char * ) NULL == ( SNP[ patientDataNo ].rsID = ( char * ) malloc ( strlen( parts[ rsColumnNumber ] ) + 1 ) ) ) { fprintf( stderr, "ERROR: Failed to allocate memory\n" ); exit ( 1 ); }
			strcpy( SNP[ patientDataNo ].rsID, parts[ rsColumnNumber ] );
			if( noParts <= rsColumnNumber ) {
				continue;
			} else if( noParts <= genotypeColumnNumber ) {
				SNP[ patientDataNo ].gType = 4;
			} else {
				if ( ( parts[ genotypeColumnNumber ][ 0 ] == 'A' ) && ( parts[ genotypeColumnNumber ][ 1 ] == 'A' ) ) { SNP[ patientDataNo ].gType = 1; AAtype++; }
				else if ( ( parts[ genotypeColumnNumber ][ 0 ] == 'B' ) && ( parts[ genotypeColumnNumber ][ 1 ] == 'B' ) ) { SNP[ patientDataNo ].gType = 2; BBtype++; }
				else if ( ( parts[ genotypeColumnNumber ][ 0 ] == 'A' ) && ( parts[ genotypeColumnNumber ][ 1 ] == 'B' ) ) { SNP[ patientDataNo ].gType = 3; ABtype++; }
				else SNP[ patientDataNo ].gType = 4;
			}
			patientDataNo++;
			if( maxLineNumber == patientDataNo ) {
				for( i = 0; i < patientDataNo; ++i ) {
					free( SNP[ i ].rsID );
				}
				free( SNP );
				free( pDSNP );
				maxLineNumber = ( long )( maxLineNumber * 1.2 );
				fclose( inf );
				goto moreMemory;
			}
		}
		fclose( inf );
		
		if ( tgPool == 0 ) {
			fprintf( stderr, "\nA total of %ld SNP typing data was read for subject %ld in the patient pool.\n", patientDataNo, j + 1 );
		} else {
			fprintf( stderr, "\nA total of %ld SNP typing data was read for subject %ld in the control pool.\n", patientDataNo, j + 1 );
		}
		fprintf( stderr, "File name = %s\n", stFile[ tgPool ][ j ] );		
		fprintf( stderr, "Numbers of valid SNPs\t%ld\n", AAtype + BBtype + ABtype );
		fprintf( stderr, "Numbers of 'AA', BB' and 'AB' type SNPs\t%ld\t%ld\t%ld\n", AAtype, BBtype, ABtype );
		//	Initialize pointer
		for ( i = 0; i < patientDataNo; ++i ) {
			pDSNP[ i ]=&( SNP[ i ] );
		}

		//	Sort patients' data using rsID as a key.
		qsort( pDSNP, patientDataNo, sizeof( pSNPdata ), comparePtRsID );
		
		//	Copy chromosome Nos., chromosome positions, AFrequency, and recordNo.
		aData = 0; failed = 0;
		i = 0; k = 0;
		while( i < patientDataNo && k < totalAnnotationDataCount ) {
			if( ( temp = strcmp( pDSNP[ i ]->rsID, pASNP[ k ]->rsID ) ) == 0 ) {
				pDSNP[ i ]->recordNo = pASNP[ k ]->recordNo;
				i++; k++;
			} else if( temp < 0 ) {
				failed++;
				pDSNP[ i ] = 0;
				i++;
			} else {
				k++;
			}
		}

		patientDataNo -= failed;
		for ( i = 0, k = 0; i < patientDataNo; ++i, ++k ) {
			while ( pDSNP[ k ] == 0 ) ++k;
			pDSNP[ i ] = pDSNP[ k ];
		}
			
		fprintf( stderr, "A total of %ld SNPs failed to find dbSNP rs ID\n", failed );

		//  Store 'A', 'B' (homozygosity haplotype) or ''  into sumSNP[].patientHap[][] and genotypes into sumSNP[].type[][].

		/* Data are stored in a little endian format */
		for( i = 0; i < patientDataNo; ++i ){
			if ( pDSNP[ i ]->gType == 1 || pDSNP[ i ]->gType == 2 || pDSNP[ i ]->gType == 3 ) {
				++nEffectiveSNP[ tgPool ][ j * ( lastChromosome - EXCLUDE_X ) + ( sumSNP[ pDSNP[ i ]->recordNo ].chromosome - 1 ) ];
			}
		}
		for( i = 0; i < patientDataNo; ++i ){		
			if ( pDSNP[ i ]->gType == 1 || pDSNP[ i ]->gType == 2 || pDSNP[ i ]->gType == 3 ) {
				putGType( sumSNP[ pDSNP[ i ]->recordNo ].gType[ tgPool ], j, pDSNP[ i ]->gType );
			} else {
				putGType( sumSNP[ pDSNP[ i ]->recordNo ].gType[ tgPool ], j, 0 );
			}
		}
		for( i = 0; i < patientDataNo + failed; ++i ){
			free( SNP[ i ].rsID );
		}
	}	// end of for (j)
	free( SNP );
	free( pDSNP );
	free( parts );
	//  At this point, all the patients' data is read and stored into sumSNP[] table.
}
