//
//	setupStartEnd.c
//
//	Programming:	Koich Hagiwara
//

#include "myHeader.h"

extern	pSummerizedSNPdata sumSNP;
extern	long totalAnnotationDataCount;
extern	struct incReg includeRegion[];
extern	long noRegions;
extern	long	*chrPosition;
extern	long	largeGap;

// Only sumSNP[].sum[] >= cutoff are output.
// If some regions fulfiled the criteria, return 1 else 0
int	Set_up_start_end( int cutoff, int mode, int tgPool, int chrNo )
{
	long	i, j, start;
	int		flag, curValue;
	long	*sum;
	int		returnValue = 0;
	
	if( ( long * ) NULL == ( sum = ( long * ) calloc( chrPosition[ chrNo + 1 ] - chrPosition[ chrNo ], sizeof( long ) ) ) ) { fprintf( stderr, "ERROR: Failed to allocate memory\n" ); exit ( 1 ); }
	for( i = chrPosition[ chrNo	]; i < chrPosition[ chrNo + 1 ]; ++ i ) {
		sumSNP[ i ].start = 0;	sumSNP[ i ].end = 0;
		if ( sumSNP[ i ].sum[ tgPool ] >= ( unsigned int )cutoff ) {
			if ( mode == 0 ) {
				sum[ i - chrPosition[ chrNo ] ] = sumSNP[ i ].sum[ tgPool ];
			} else if ( mode == 1 ) {
				sum[ i - chrPosition[ chrNo ] ] = 1;
			}
		} else {
			sum[ i - chrPosition[ chrNo ] ] = 0;
		}
	}
	
	for( i = 0; i < noRegions; ++ i ) {
		if( chrPosition[ chrNo ] <= includeRegion[ i ].start && includeRegion[ i ].end < chrPosition[ chrNo + 1 ] ) {
			for ( flag = 0, j = includeRegion[ i ].start; j <= includeRegion[ i ].end; ++j ) {
				if ( flag == 0 ) {
					if ( sum[ j - chrPosition[ chrNo ] ] != 0 ) {
						if ( j == includeRegion[ i ].end ) {
							sumSNP[ j ].start = 1;  sumSNP[ j ].end = 1;
							flag = 0;	curValue = 0;	returnValue = 1;
						} else if ( sumSNP[ j + 1 ].position - sumSNP[ j ].position >= largeGap ) {
							sumSNP[ j ].start = 1;  sumSNP[ j ].end = 1;
							flag = 0;	curValue = 0;	returnValue = 1;
						} else if ( sum[ j + 1 - chrPosition[ chrNo ] ] != sum[ j - chrPosition[ chrNo ] ] ) {
							sumSNP[ j ].start = 1;  sumSNP[ j ].end = 1;
							flag = 0;	curValue = 0;	returnValue = 1;
						} else {
							start = j;
							flag = 1;	curValue = sum[ j - chrPosition[ chrNo ] ];
						}
					}
				} else if ( flag == 1 ) {
					if ( j == includeRegion[ i ].end ) {
						if ( sum[ j - chrPosition[ chrNo ] ] != curValue ) {
							sumSNP[ start ].start = 1;  sumSNP[ j - 1 ].end = 1;
							if ( sum[ j - chrPosition[ chrNo ] ] != 0 ) { sumSNP[ j ].start = 1; sumSNP[ j ].end = 1; }
							flag = 0;	curValue = 0;	returnValue = 1;
						} else {
							sumSNP[ start ].start = 1;  sumSNP[ j ].end = 1;
							flag = 0;	curValue = 0;	returnValue = 1;
						}
					} else if ( sumSNP[ j + 1 ].position - sumSNP[ j ].position >= largeGap ) {
						if ( sum[ j - chrPosition[ chrNo ] ] != curValue ) {
							sumSNP[ start ].start = 1;  sumSNP[ j - 1 ].end = 1;	
							if ( sum[ j - chrPosition[ chrNo ] ] != 0 ) { sumSNP[ j ].start = 1; sumSNP[ j ].end = 1; }
							flag = 0;	curValue = 0;	returnValue = 1;
						} else {
							sumSNP[ start ].start = 1;  sumSNP[ j ].end = 1;
							flag = 0;	curValue = 0;	returnValue = 1;
						}
					} else if ( sum[ j + 1 - chrPosition[ chrNo ] ] != sum[ j - chrPosition[ chrNo ] ] ) {
						sumSNP[ start ].start = 1;  sumSNP[ j ].end = 1;
						flag = 0;	curValue = 0;	returnValue = 1;
					}
				}
			}
		}
	 }
	free( sum );
	return returnValue;
}
