//
//	significance.c
//
//	Programming:	Koich Hagiwara
//

#include "myHeader.h"

extern	pSummerizedSNPdata sumSNP;
extern	long	totalAnnotationDataCount;
extern	struct	incReg	includeRegion[];
extern	long	noRegions;
extern	int		enum_significance;
extern	char	*outputFilePath;
extern	struct	colorBar cb[];
extern	int		noTgPool[ 2 ];
extern	int		lastChromosome;

void	significance( char *outputfilePS, char *outputfileText ){

	long	i, j, i2;
	char	outfilename[STRINGBUFFERSIZE];
	long	cutoff;
	int		mode;
	float	maxP;
	float	jackup;

	for( i2 = 0; i2 < noRegions; ++ i2 ) {	
		for ( i = includeRegion[ i2 ].start; i <= includeRegion[ i2 ].end; ++i ) {	
			//	Up to 256 * 256 files can be accomodated.
			sumSNP[ i ].sum[ enum_significance ] = sumSNP[ i ].ptInvolved[ 0 ] * 256 * 256 + sumSNP[ i ].ptInvolved[ 1 ];
		}
	}
	//	For a birds eye view, cutoff is 0 (all data considered) and mode is 0 (color).
	cutoff = 0L; mode = 0;
	//	When the mode is 0, different values are treated as different values.
	for( i = 0; i < lastChromosome - EXCLUDE_X; ++i ) {
		Set_up_start_end( cutoff, mode, enum_significance, i );
	}

	for( i2 = 0, maxP = 0.0; i2 < noRegions; ++ i2 ) {		
		for ( i = includeRegion[ i2 ].start; i <= includeRegion[ i2 ].end; ++i ) {	//	j moves within a region.
			if ( ( sumSNP[ i ].start == 1 ) || ( sumSNP[ i ].end == 1 ) ) {
				sumSNP[ i ].p =  ( float )( log ( 1.0 / p_value ( noTgPool[ 0 ], noTgPool[ 1 ], sumSNP[ i ].ptInvolved[ 0 ], sumSNP[ i ].ptInvolved[ 1 ] ) ) / log ( 10.0 ) );	//	Obtain -log (p).
			}
			if ( sumSNP[ i ].p > maxP ) maxP = sumSNP[ i ].p;		}
	}
	jackup = JACKUP;
	for( i = 0; i < noRegions; ++ i ) {	
		for ( j = includeRegion[ i ].start; j <= includeRegion[ i ].end; ++j ) {	//	j moves within a region.
			sumSNP[ j ].color = ( float )( 1.0 - jackup - ( 1.0 - jackup ) * sumSNP[ j ].p * sumSNP[ j ].p * sumSNP[ j ].p / maxP / maxP / maxP );			
		}
	}

	for ( i = 0; i < 5; ++ i ) {
		cb[ i ].color = 1.0 - jackup - ( 1.0 - jackup ) * maxP * ( 1.0 - 0.2 * i ) * maxP * ( 1.0 - 0.2 * i ) * maxP * ( 1.0 - 0.2 * i ) / maxP / maxP / maxP;
		cb[ i ].number = maxP * ( 1.0 - 0.2 * i );
	}
	
	sprintf( outfilename, "%s", outputfilePS );
	Output_birds_eye_viewPS ( outfilename, enum_significance );
	sprintf( outfilename, "%s", outputfileText );
	fOutput_start_end_text ( outfilename, "", enum_significance );
}
